﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@

Sub Class_Globals
	Private Root As B4XView
	Public xui As XUI
	Public IME1 As IME
	Public dialog As B4XDialog
	Public Dialog2 As B4XDialog
	Public Dialog3 As B4XDialog
	Public f As B4XFormatter
	Public KVS_Settings As KeyValueStore
	Public B4XTable_Products As B4XTable
	Public sunmi As SunmiScanner
	Public rp As RuntimePermissions
	Public fFileProvider As FileProvider
	
	Public Date As String
	Public Time As String 
	Public Sale_ID As String
	
	Private clvProduct_Sales As CustomListView
	Private txtProduct_Code As B4XView
	Private txtSubtotal As B4XView
	
	Public Scanned_Barcode As String
	Private lblProd_Name As Label
	Private pnlBottomSale As B4XView
	
	Private btnMenu_New As B4XView
	Private btnMenu_Pay As B4XView
	Private btnEnterProductCode As B4XView
	
	Public Sale_Complete As Boolean
	Public Invoice_No As Int
	Private pnlMainSalesPage As B4XView
	Private lblSubtotal As B4XView
	Private pnlSearchCode As B4XView
	
	Public Search_String As Boolean
	Private pnlSearchTable As Panel
	Private lblSel_Prod_Name As B4XView
	Private txtSelQuantity As EditText
	Private btnInsertSelected As Button
	Private btnCancelSelected As Button
	Private pnlSelectedProduct As B4XView
	Private lblSel_Unit_Price As B4XView
	
	Public Product_Code As Long
	Public Product_Name As String
	Public Product_Price As Float
	Public Product_QTY As Int
	Public Line_Total As Float
	Public Sale_Total As Float

	Public CLV_Product_Code As Long
	Public CLV_Product_Name As String
	Public CLV_Product_Price As Float
	Public CLV_Product_QTY As Int
	Public CLV_Line_Total As Float
	Public CLV_Total As Float
	
	Private pnlSearchOptions As B4XView

	Private btn_Delete_Line As Button
	Private lbl_Line_Total As Label
	Private lbl_Product_Price As Label
	Private txtEnterQTY As EditText
	Private btnMinus As Button
	Private btnPlus As Button
End Sub

Public Sub Initialize
	KVS_Settings.Initialize(File.DirInternal, "Settings.dat")
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("Layout_Sales2")
	Root.Color = xui.Color_White
	pnlBottomSale.Visible = False
	btnMenu_Pay.Enabled = False
	btnMenu_New.Enabled = False
	pnlSearchTable.Visible = False
	pnlSelectedProduct.Visible = False
	pnlSearchOptions.Visible = True
	
'	Formatting decimals
	f.Initialize
	Dim DefaultFormat As B4XFormatData = f.GetDefaultFormat
	
	DefaultFormat.MaximumFractions = 2
	DefaultFormat.MinimumFractions = 2
	DefaultFormat.Prefix = "R "
	
	DateTime.DateFormat = "yyyyMMdd"
	DateTime.TimeFormat = "HHmmss"

	Dialog2.Initialize(Root)
	Sunmi_Initialize
	
End Sub

Public Sub B4xPage_Appear
	Root.LoadLayout("Layout_Sales2")
	Root.Color = xui.Color_White
	pnlBottomSale.Visible = False
	btnMenu_Pay.Enabled = False
	btnMenu_New.Enabled = False
	pnlSearchTable.Visible = False
	pnlSelectedProduct.Visible = False
	pnlSearchOptions.Visible = True
	
	Product_Name = ""
	Product_QTY = 0
	Line_Total = 0
	Sale_Total = 0
End Sub

Public Sub Sunmi_Initialize
	sunmi.Initialize("Sunmi")
	sunmi.bindScannerService
	sunmi.registerReceiver
End Sub

Public Sub Sunmi_Result( Raw_Barcode As String)
	Dim Split_Barcode() As String
	Dim RegexPattern As String = "\b\w{1,3}"
	Split_Barcode = Regex.Split(RegexPattern,Raw_Barcode)
	Scanned_Barcode = Split_Barcode(1)
	Perform_Sale
End Sub

Public Sub Perform_Sale

	Dim now As Long = DateTime.Now
	Date = DateTime.Date(now)
	Time = DateTime.Time(now)
	Dim ProdCode As String
	If txtProduct_Code.Text = "" Then
		ProdCode = Scanned_Barcode
		Else
		ProdCode = txtProduct_Code.Text
	End If
	Dim rs As ResultSet =Starter.SQL1.ExecQuery2("SELECT * FROM POS_Products  WHERE Product_Code = ? ", Array As  String(ProdCode))
	If rs.RowCount > 0 Then
	Do While rs.NextRow
			Dim row(4) As Object
			row(0) = rs.GetDouble("Product_Code")
			row(1) = rs.GetString("Product_Name")
			row(2) = rs.GetDouble("Product_Price")
			Product_Code = row(0)
			Product_Name = row(1)
			Product_Price = row(2)
			NumberFormat(Product_Code,1,0)
			Line_Total = (Product_Price*Product_QTY)
			Sale_Total = Sale_Total + Line_Total
		Dim p As B4XView = xui.CreatePanel("")
		p.SetLayoutAnimated(0, 0, 0, Root.Width, 120dip)
		p.LoadLayout("Layout_Sales_View")
			
			CLV_Product_Code = Product_Code
			CLV_Product_Name = Product_Name
			CLV_Product_Price = Product_Price
			CLV_Product_QTY = Product_QTY
			CLV_Line_Total = Line_Total
			CLV_Total = Sale_Total
			Sale_ID = Date&Time
			Add_to_CLV
	Loop
	Else
		xui.MsgboxAsync("The product code you entered is not valid. Please re-scan or enter correct one to continue", "Attention!")
	End If
	txtProduct_Code.Text = ""
End Sub

Public Sub Add_to_CLV
	
		Dim p As B4XView = xui.CreatePanel("")
		p.SetLayoutAnimated(0, 0, 0, Root.Width, 100dip)
		p.LoadLayout("Layout_Sales_View")
				
	lblProd_Name.Text = CLV_Product_Name
	lbl_Product_Price.Text =  f.Format(Product_Price)
	lbl_Line_Total.Text =  f.Format(CLV_Line_Total)
	txtSubtotal.Text =  CLV_Total
				
	Dim prod_list As List
	prod_list.Initialize
	prod_list.AddAll(Array As String(CLV_Product_Code, Sale_ID, CLV_Product_Name , CLV_Product_Price, CLV_Product_QTY, CLV_Line_Total))
	clvProduct_Sales.Add(p,prod_list)
	btnMenu_New.Enabled = False
	pnlBottomSale.Visible = True
	btnMenu_Pay.Enabled = True
	btnMenu_New.Enabled = True

End Sub

Private Sub btSearch_Click
	pnlSearchCode.Visible = False
	pnlSearchTable.Visible = True
End Sub
Private Sub btnEnterProductCode_Click
	Perform_Sale
	IME1.HideKeyboard
End Sub

Private Sub btnPlus_Click

	Dim index As Int = clvProduct_Sales.GetItemFromView(Sender)
	Dim p As Panel = clvProduct_Sales.GetPanel(index)
	
	Log("0 = " & p.GetView(0))
	Log("1 = " & p.GetView(1))
	Log("2 = " & p.GetView(2))
	Log("3 = " & p.GetView(3))
	Log("4 = " & p.GetView(4))
	Log("5 = " & p.GetView(5))
		
	Dim txtEnterQTY As EditText = p.GetView(3)
	Dim lblLine_Total As Label = p.GetView(5)
	If IsNumber(txtEnterQTY.Text) Then
		Product_QTY = txtEnterQTY.Text
	Else
		Product_QTY = 0
	End If
	
	Product_QTY = Product_QTY + 1 ' Increase quantity by 1
	txtEnterQTY.Text = Product_QTY ' Update EditText
	Line_Total = Product_QTY*Product_Price
	lblLine_Total.Text =  f.Format(Line_Total)
	lblSubtotal.Text =  f.Format(Sale_Total)
End Sub

Private Sub btnMinus_Click
	Dim index As Int = clvProduct_Sales.GetItemFromView(Sender)
	Dim p As Panel = clvProduct_Sales.GetPanel(index)
	Dim txtEnterQTY As EditText = p.GetView(3)
	Dim lblLine_Total As Label = p.GetView(5)
	If IsNumber(txtEnterQTY.Text) Then
		Product_QTY = txtEnterQTY.Text
	Else
		Product_QTY = 0
	End If
	If Product_QTY > 0 Then
		Product_QTY = Product_QTY - 1 ' Decrease quantity by 1
	End If
	
	txtEnterQTY.Text = Product_QTY ' Update EditText
	Line_Total= Product_QTY*Product_Price
	lblLine_Total.Text =  f.Format(Line_Total)
	lblSubtotal.Text =  f.Format(Sale_Total)
End Sub

Private Sub txtEnterQTY_EnterPressed
	Product_QTY = txtEnterQTY.Text  ' Update EditText
	Line_Total= Product_QTY*Product_Price
	lbl_Line_Total.Text =  f.Format(Line_Total)
End Sub

